# CentOS

[CentOS](http://centos.org/) has joined forces with Red Hat, working to provide a common platform for open source community project needs.
Since [RedHat](http://www.redhat.com/) is one of the preferred Linux platform for all EDA vendors, this page lists all the packages that 
were required to be installed on top of the typical installation to run the CONNECTAL framework. 
Vivado-14.1 also lists native support for CentOS in their [release notes](http://www.xilinx.com/support/documentation/sw_manuals/xilinx2014_1/ug973-vivado-release-notes-install-license.pdf).

# yum

RedHat/CentOS uses [yum](http://www.ibm.com/developerworks/library/l-lpic1-v3-102-5/) to fetch packages and install RPMs whereas Ubuntu which is derived from Debian distribution
uses [apt](http://www.ibm.com/developerworks/linux/library/l-lpic1-v3-102-4/) commands to install packages. All the packages installed using yum [commands](http://yum.baseurl.org/wiki/YumCommands) need sudo or root privileges.

# Packages

The following table lists the package name, the command used to install the package followed by a brief comment.

<table border="2" cellspacing="0" cellpadding="6" rules="all" frame="border">


<colgroup>
<col  class="left" />

<col  class="left" />

<col  class="left" />
</colgroup>
<thead>
<tr>
<th scope="col" class="left">**package name**</th>
<th scope="col" class="left">**installation command**</th>
<th scope="col" class="left">**comment**</th>
</tr>
</thead>

<tbody>
<tr>
<td class="left">32-bit libstdc</td>
<td class="left">sudo yum install “Compatibility libraries”</td>
<td class="left">arm-xilinx-linux-gnueabi-g++ needs 32-bit libs</td>
</tr>


<tr>
<td class="left">[LiberOffice](http://www.libreoffice.org/)</td>
<td class="left">sudo yum groupinstall “Office Suite and Productivity”</td>
<td class="left">Optional (groupinfo will list packages)</td>
</tr>


<tr>
<td class="left">[flashplayer](http://get.adobe.com/flashplayer/)</td>
<td class="left">sudo yum install flash-plugin nspluginwrapper curl</td>
<td class="left">For several viewing video tutorials, e.g. [vivado training](http://www.xilinx.com/training/vivado/)</td>
</tr>
</tbody>

<tbody>
<tr>
<td class="left">python-ply</td>
<td class="left">sudo yum install python-ply</td>
<td class="left">Python Lex-Yacc</td>
</tr>


<tr>
<td class="left">python-argparse</td>
<td class="left">sudo yum install python-argparse</td>
<td class="left">Parser for command-line options, arguments and sub-commands</td>
</tr>
</tbody>

<tbody>
<tr>
<td class="left">[graphviz](http://www.graphviz.org/Download_linux_rhel.php)</td>
<td class="left">sudo yum install graphviz graphviz-tcl</td>
<td class="left">To view dot files generated by "bsc -sched-dot"</td>
</tr>
</tbody>

<tbody>
<tr>
<td class="left">ftp client</td>
<td class="left">sudo yum install ftp</td>
<td class="left">[needed for running out-of-the-box Linux example](http://zedboard.org/content/zedboard-setting-arm-development-environment-linux)</td>
</tr>


<tr>
<td class="left">cable drivers</td>
<td class="left">&#xa0;</td>
<td class="left">[Install Instructions](http://www.xilinx.com/support/answers/29310.htm)</td>
</tr>


<tr>
<td class="left">[fxload](http://pkgs.org/centos-6-rhel-6/linuxtech-x86_64/fxload-2008_10_13-3.el6.x86_64.rpm.html)</td>
<td class="left">&#xa0;</td>
<td class="left">Used to update the firmware of the platform cable.</td>
</tr>


<tr>
<td class="left">ldd \`which docnav\`</td>
<td class="left">&#xa0;</td>
<td class="left">Need to install "not found" libs for running Xilinx docnav</td>
</tr>


<tr>
<td class="left">&#xa0;</td>
<td class="left">sudo yum whatprovides libgthread-2.0.so.0</td>
<td class="left">repo: glib2-2.26.1-3.el6.i686</td>
</tr>


<tr>
<td class="left">libpng12.so.0</td>
<td class="left">sudo yum install 2:libpng-1.2.49-1.el6\_2.i686</td>
<td class="left">A library of functions for manipulating PNG image format files</td>
</tr>


<tr>
<td class="left">libfontconfig.so.1</td>
<td class="left">sudo yum install fontconfig-2.8.0-3.el6.i686</td>
<td class="left">Font configuration and customization library</td>
</tr>


<tr>
<td class="left">libfreetype.so.6</td>
<td class="left">sudo yum install freetype-2.3.11-14.el6\_3.1.i686</td>
<td class="left">A free and portable font rendering engine</td>
</tr>


<tr>
<td class="left">libXext.so.6</td>
<td class="left">sudo yum install libXext.so.6</td>
<td class="left">X.Org X11 libXext runtime library</td>
</tr>


<tr>
<td class="left">libXrender.so.q</td>
<td class="left">sudo yum install libXrender-0.9.7-2.el6.i686</td>
<td class="left">X.Org X11 libXrender runtime library</td>
</tr>


<tr>
<td class="left">libstdc++.so.6</td>
<td class="left">sudo yum install libstdc++-4.4.7-4.el6.i686</td>
<td class="left">GNU Standard C++ Library</td>
</tr>


<tr>
<td class="left">libgthread-2.0.so.0</td>
<td class="left">sudo yum install glib2-2.26.1-3.el6.i686</td>
<td class="left">A library of handy utility functions</td>
</tr>


<tr>
<td class="left">libSM.so.6</td>
<td class="left">sudo yum install libSM-1.2.1-2.el6.i686</td>
<td class="left">X.Org X11 SM runtime library</td>
</tr>


<tr>
<td class="left">libICE.so.6</td>
<td class="left">sudo yum install libICE-1.0.6-1.el6.i686</td>
<td class="left">X.Org X11 ICE runtime library</td>
</tr>


<tr>
<td class="left">libX11.so.6</td>
<td class="left">sudo yum install libX11-1.5.0-4.el6.i686</td>
<td class="left">Core X11 protocol client library</td>
</tr>


<tr>
<td class="left">&#xa0;</td>
<td class="left">cd /<pkg-dir>/xilinx/14.7/ISE\_DS/ISE/lib/lin64</td>
<td class="left">To fix 'GLIBCXX\_3.4.9' not found</td>
</tr>


<tr>
<td class="left">&#xa0;</td>
<td class="left">sudo mv libstdc++.so libstdc++.so.orig</td>
<td class="left">Do the same also in the following directories:</td>
</tr>


<tr>
<td class="left">&#xa0;</td>
<td class="left">sudo mv libstdc++.so.6 libstdc++.so.6.orig</td>
<td class="left">*<pkg-dir>/xilinx/14.7/ISE\_DS/common/lib/lin64*</td>
</tr>


<tr>
<td class="left">&#xa0;</td>
<td class="left">sudo mv libstdc++.so.6.0.8 libstdc++.so.6.0.8.orig</td>
<td class="left">/<pkg-dir>/xilinx/Vivado/2013.3/ids\_lite/ISE/lib/lin64</td>
</tr>
</tbody>

<tbody>
<tr>
<td class="left">emacs 24.3</td>
<td class="left">&#xa0;</td>
<td class="left">[Install instructions](http://h1de0ut.com/bl0g/article/2012/03/01/emacs24-ricty-centos6/)  (for better org mode support)</td>
</tr>
</tbody>
</table>